import Vue from "vue";
// import resource from "vue-resource";
import VueAxios from "vue-axios";
import axios from "axios";
// import Qs from "qs";

export default {
  methods: {
    loadData() {
      if (this.dataUrl) {
        this.remoteData();
      }
      else if (this.dataJson && this.dataJson.length > 0) {
        if (this.pager) {
          this.source = this.resolvePager(this.dataJson, (this.pager.currentPage || 1), this.pager.pageSize);
          this.$set(this.pager, "total", this.dataJson.length);
        }
        else {
          this.source = this.dataJson;
        }
      }
    },
    remoteData() {
      // Vue.use(resource);
      Vue.use(VueAxios, axios);
      let url = this.dataUrl;
      let remoteParam = {};
      let paramStr = "";
      let icon = url && url.indexOf("?") > -1 ? "&" : "?";

      if (this.pager) {
        remoteParam = {
          pageInt: this.pager.currentPage || 1,
          pageSize: this.pager.pageSize
        };

        for (let key in remoteParam) {
          let value = remoteParam[key];
          paramStr += paramStr === "" ? `${icon}${key}=${value}` : `&${key}=${value}`;
        }
      }

      this.beforeLoadData();
      // let config = {
      //   headers: {
      //     "Content-Type": "application/x-www-form-urlencoded"
      //   }
      // };
      // this.$http.post(url, Qs.stringify(remoteParam), config).then(response => {
      this.$http.get(url + paramStr).then(response => {
        // console.log("成功");
        // console.log(response);
        let result = response.data;

        if (result.errorMsg) {
          this.$message.error(result.errorMsg);
        }
        // 后台菜单返回数据如果没有分页的,直接返回list,如果返回带分页,会返回{list: data, total: count}格式
        else if (result.data && result.data.list) {
          this.source = result.data.list;
        }
        else if (result.data) {
          this.source = result.data;
        }
        if (this.pager && result.data) {
          this.$set(this.pager, "total", result.data.total);
        }
        this.loadComplete();
      }, response => {
        this.$message.error("调取远程数据失败: " + JSON.stringify(response));
      });
    },
    beforeLoadData() {},
    loadComplete() {}
  },
  mounted() {
    this.loadData();
  }
};
